PyBytecode (Jython API documentation)
Date: 2022-09-10

org.python.core

## Class PyBytecode

- java.lang.Object
- - org.python.core.PyObject
  - - org.python.core.PyCode
    - - org.python.core.PyBaseCode
      - - org.python.core.PyBytecode

- All Implemented Interfaces:
    java.io.Serializable, Traverseproc

      public class PyBytecode
      extends PyBaseCode
      implements Traverseproc

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.python.core.PyObject

      `PyObject.ConversionException`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `byte[]` | `co_code`
    `PyObject[]` | `co_consts`
    `byte[]` | `co_lnotab`
    `static int` | `CO_MAXBLOCKS`
    `java.lang.String[]` | `co_names`
    `int` | `co_stacksize`
    `static boolean` | `defaultDebug`

    - ### Fields inherited from class org.python.core.PyBaseCode

      `co_argcount, co_cellvars, co_filename, co_firstlineno, co_flags, co_freevars, co_nlocals, co_varnames, jy_npurecell, varargs, varkwargs`

    - ### Fields inherited from class org.python.core.PyCode

      `co_name`

    - ### Fields inherited from class org.python.core.PyObject

      `gcMonitorGlobal, TYPE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PyBytecode(int argcount, int nlocals, int stacksize, int flags, java.lang.String codestring, PyObject[] constants, java.lang.String[] names, java.lang.String[] varnames, java.lang.String filename, java.lang.String name, int firstlineno, java.lang.String lnotab)`
    `PyBytecode(int argcount, int nlocals, int stacksize, int flags, java.lang.String codestring, PyObject[] constants, java.lang.String[] names, java.lang.String[] varnames, java.lang.String filename, java.lang.String name, int firstlineno, java.lang.String lnotab, java.lang.String[] cellvars, java.lang.String[] freevars)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `__delattr__(java.lang.String name)` A variant of the __delattr__ method which accepts a String as the key.
    `PyObject` | `__dir__()` Equivalent to the standard Python __dir__ method.
    `PyObject` | `__findattr_ex__(java.lang.String name)` Attribute lookup hook.
    `void` | `__setattr__(java.lang.String name, PyObject value)` A variant of the __setattr__ method which accepts a String as the key.
    `static void` | `_allDebug(boolean setting)`
    `PyObject` | `_debug(int maxCount)`
    `boolean` | `refersDirectlyTo(PyObject ob)` Optional operation.
    `int` | `traverse(Visitproc visit, java.lang.Object arg)` Traverses all directly contained `PyObject`s.

    - ### Methods inherited from class org.python.core.PyBaseCode

      `call, call, call, call, call, call, call, call, getCompilerFlags, hasFreevars, toString`

    - ### Methods inherited from class org.python.core.PyCode

      `call, call`

    - ### Methods inherited from class org.python.core.PyObject

      `__abs__, __add__, __and__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __cmp__, __coerce__, __coerce_ex__, __complex__, __contains__, __delattr__, __delete__, __delitem__, __delitem__, __delslice__, __delslice__, __div__, __divmod__, __ensure_finalizer__, __eq__, __findattr__, __findattr__, __finditem__, __finditem__, __finditem__, __float__, __floordiv__, __format__, __ge__, __get__, __getattr__, __getattr__, __getitem__, __getitem__, __getnewargs__, __getslice__, __getslice__, __gt__, __hash__, __hex__, __iadd__, __iand__, __idiv__, __idivmod__, __ifloordiv__, __ilshift__, __imod__, __imul__, __index__, __int__, __invert__, __ior__, __ipow__, __irshift__, __isub__, __iter__, __iternext__, __itruediv__, __ixor__, __le__, __len__, __long__, __lshift__, __lt__, __mod__, __mul__, __ne__, __neg__, __nonzero__, __not__, __oct__, __or__, __pos__, __pow__, __pow__, __radd__, __rand__, __rdiv__, __rdivmod__, __reduce__, __reduce_ex__, __reduce_ex__, __repr__, __rfloordiv__, __rlshift__, __rmod__, __rmul__, __ror__, __rpow__, __rrshift__, __rshift__, __rsub__, __rtruediv__, __rxor__, __set__, __setattr__, __setitem__, __setitem__, __setitem__, __setslice__, __setslice__, __str__, __sub__, __tojava__, __truediv__, __trunc__, __unicode__, __xor__, _add, _and, _callextra, _cmp, _div, _divmod, _doget, _doget, _doset, _eq, _floordiv, _ge, _gt, _iadd, _iand, _idiv, _idivmod, _ifloordiv, _ilshift, _imod, _imul, _in, _ior, _ipow, _irshift, _is, _isnot, _isub, _itruediv, _ixor, _jcall, _jcallexc, _jthrow, _le, _lshift, _lt, _mod, _mul, _ne, _notin, _or, _pow, _rshift, _sub, _truediv, _xor, asDouble, asIndex, asIndex, asInt, asInt, asIterable, asLong, asLong, asName, asName, asString, asString, asStringOrNull, asStringOrNull, bit_length, conjugate, delDict, delType, dispatch__init__, equals, fastGetClass, fastGetDict, getDict, getType, hashCode, implementsDescrDelete, implementsDescrGet, implementsDescrSet, invoke, invoke, invoke, invoke, invoke, invoke, isCallable, isDataDescr, isIndex, isInteger, isMappingType, isNumberType, isSequenceType, noAttributeError, object___subclasshook__, readonlyAttributeError, setDict, setType`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### defaultDebug

          public static boolean defaultDebug

    - #### CO_MAXBLOCKS

          public static final int CO_MAXBLOCKS

      See Also:
        Constant Field Values

    - #### co_code

          public final byte[] co_code

    - #### co_consts

          public final PyObject[] co_consts

    - #### co_names

          public final java.lang.String[] co_names

    - #### co_stacksize

          public final int co_stacksize

    - #### co_lnotab

          public final byte[] co_lnotab

  - ### Constructor Detail

    - #### PyBytecode

          public PyBytecode(int argcount,
                            int nlocals,
                            int stacksize,
                            int flags,
                            java.lang.String codestring,
                            PyObject[] constants,
                            java.lang.String[] names,
                            java.lang.String[] varnames,
                            java.lang.String filename,
                            java.lang.String name,
                            int firstlineno,
                            java.lang.String lnotab)

    - #### PyBytecode

          public PyBytecode(int argcount,
                            int nlocals,
                            int stacksize,
                            int flags,
                            java.lang.String codestring,
                            PyObject[] constants,
                            java.lang.String[] names,
                            java.lang.String[] varnames,
                            java.lang.String filename,
                            java.lang.String name,
                            int firstlineno,
                            java.lang.String lnotab,
                            java.lang.String[] cellvars,
                            java.lang.String[] freevars)

  - ### Method Detail

    - #### _allDebug

          public static void _allDebug(boolean setting)

    - #### _debug

          public PyObject _debug(int maxCount)

    - #### __dir__

          public PyObject __dir__()

      Description copied from class: `PyObject`
      Equivalent to the standard Python __dir__ method.
      Overrides:
        `__dir__` in class `PyObject`
      Returns:
        a list of names defined by this object.

    - #### __setattr__

          public void __setattr__(java.lang.String name,
                                  PyObject value)

      Description copied from class: `PyObject`
      A variant of the __setattr__ method which accepts a String as the key. This String must be interned.
      Overrides:
        `__setattr__` in class `PyObject`
      Parameters:
        `name` - the name whose value will be set - must be an interned string .
        `value` - the value to set this name to
      See Also:
        `PyObject.__setattr__(PyString, PyObject)`

    - #### __delattr__

          public void __delattr__(java.lang.String name)

      Description copied from class: `PyObject`
      A variant of the __delattr__ method which accepts a String as the key. This String must be interned. By default, this will call `__delattr__(PyString name)` with the appropriate args. The only reason to override this method is for performance.
      Overrides:
        `__delattr__` in class `PyObject`
      Parameters:
        `name` - the name which will be removed - must be an interned string .
      See Also:
        `PyObject.__delattr__(PyString)`

    - #### __findattr_ex__

          public PyObject __findattr_ex__(java.lang.String name)

      Description copied from class: `PyObject`
      Attribute lookup hook. If the attribute is not found, null may be returned or a Py.AttributeError can be thrown, whatever is more correct, efficient and/or convenient for the implementing class. Client code should use `PyObject.__getattr__(String)` or `PyObject.__findattr__(String)`. Both methods have a clear policy for failed lookups.
      Overrides:
        `__findattr_ex__` in class `PyObject`
      Returns:
        The looked up value. May return null if the attribute is not found

    - #### traverse

          public int traverse(Visitproc visit,
                              java.lang.Object arg)

      Description copied from interface: `Traverseproc`
      Traverses all directly contained `PyObject`s. Like in CPython, `arg` must be passed unmodified to `visit` as its second parameter. If `Visitproc.visit(PyObject, Object)` returns nonzero, this return value must be returned immediately by traverse. `Visitproc.visit(PyObject, Object)` must not be called with a `null` PyObject-argument.
      Specified by:
        `traverse` in interface `Traverseproc`

    - #### refersDirectlyTo

          public boolean refersDirectlyTo(PyObject ob)

      Description copied from interface: `Traverseproc`
      Optional operation. Should only be implemented if it is more efficient than calling `Traverseproc.traverse(Visitproc, Object)` with a visitproc that just watches out for `ob`. Must return `false` if `ob` is `null`.
      Specified by:
        `refersDirectlyTo` in interface `Traverseproc`

Jython homepage